#!/usr/bin/php
<?php
$tenantID = "";
$clientID = "";
$key = '';
require_once '/usr/local/esia/plugins/lib/CacheFile.class.php';
$CACHEDIRECTORY='/tmp/o365/';

$ERROR=array('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3);
$SHORT_OPTS="hVw:c:n:jt:A:U:K:T:Da:";
$LONG_OPTS=array("warning:","critical:","help","debug","name:","json",'type:','authfile:','tenant:','client:','key:','debug','args:');
$options = getopt($SHORT_OPTS, $LONG_OPTS);


if ( isset($options["help"]) || isset($options["h"]) ){
	print_help();
	exit($INT_STATUS["UNKNOWN"]);
}

$name 		= getParam($options,"name","n",null);
$warning 	= getParam($options,"warning","w",80);
$critical 	= getParam($options,"critical","c",90);
$json 	    = getParam($options,"json","j",null);
$type 	    = getParam($options,"type","t","check");
$authfile 	= getParam($options,"authfile","A",null);
$tenantID 	= getParam($options,"tenant","T",null);
$clientID 	= getParam($options,"client","U",null);
$key 	    = getParam($options,"key","K",null);
$debug 	    = getParam($options,"debug","D",null);
$extraparams= getParam($options,"args","a",null);
if(isset($debug))
{
    echo "Debug mode enable\n";
    $debug=true;
}
if(!empty($authfile))
{
    $string = file_get_contents($authfile);
    $auths = json_decode($string,true);
    if(json_last_error() === JSON_ERROR_NONE)
    {
       $tenantID =$auths['tenantID'];
       $clientID =$auths['clientID'];
       $key =$auths['key'];
    }
    else
    {
        $lines = explode("\n",$string);
        foreach($lines as $line)
        {
            $line = trim($line);
            if(preg_match('#tenantID=(.*)#',$line,$regs))
            {
                $tenantID =trim($regs[1]);
            }
            elseif(preg_match('#clientID=(.*)#',$line,$regs))
            {
                $clientID =trim($regs[1]);
            }
            elseif(preg_match('#key=(.*)#',$line,$regs))
            {
                $key =trim($regs[1]);
            }
        }
    }
}
if(empty($tenantID)||empty($clientID)||empty($key) )
{
    echo "Bad authenfication parameter, check tenantID, clientID or Key access\n";
    exit($ERROR['UNKNOWN']);
}
if( is_dir($CACHEDIRECTORY) == FALSE)
{
    if(mkdir($CACHEDIRECTORY,0755)==FALSE)
    {
        echo "Can't create direcotry cache\n";
        exit($ERROR['UNKNOWN']);
    }
}

$return = $ERROR['OK'];
try
{
    $api =  new Microsoft365($tenantID,$CACHEDIRECTORY,$debug);
    $api->Trace("Debug mode enable");
    $output="";
    if($type =='messageasss'  )
    {
        $api->authentification($clientID,$key);
    }
    else
    {
        $api->authentification($clientID,$key,'graph');
    }
    $api->Trace("TYPE:".$type);
    if($type =='usersLicence')
    {
        $output = $api->getUserActivate();
    }
    elseif($type =='usersCount')
    {
        $day=7;
        if(isset($extraparams))
        {
            if(preg_match('#days=([0-9]*)#',$extraparams,$regs))
            {
                $day = $regs[1];
            }
        }
        $output = $api->getUserStatistic($day);
    }
    elseif($type =='onedrive')
    {
        $day=7;
        if(isset($extraparams))
        {
            if(preg_match('#days=([0-9]*)#',$extraparams,$regs))
            {
                $day = $regs[1];
            }
        }
        if($name=='filestat')
        {
            $output = $api->getOnedriveFileCount($day);
        }
        elseif($name=='fileactivity')
        {
            $output = $api->getOnedriveFileActivity($day);
        }
        elseif($name=='userstat')
        {
            $output = $api->getOnedriveUserCount($day);
        }
        elseif($name=='userstatdetail')
        {
            $output = $api->getOnedriveUserDetail($day);
        }
        else
        {
            $tmp = $api->getOnedriveStorage($day);
            if(isset($json))
            {
                $output = $tmp;
            }
            else
            {
                $max = 1024*1024*1024*1024;
                $messagewarning =  $warning;
                $messagecritical =  $critical;
                if(preg_match('#subscribe=([0-9]*)([GB|TB]*)#',$extraparams,$regs))
                {
                    $max = $regs[1];
                    $unit = $regs[2];
                    if($unit=='TB')
                    {
                        $max=$max*1024;
                    }
                    $max=$max*1024*1024*1024;
                }
                if(!is_numeric($warning))
                {
                    if(preg_match('#([0-9]*)([GB|TB]*)#',$warning,$regs))
                    {
                        if($regs[2]=='TB')
                        {
                            $warning=$regs[1]*1024;
                        }
                        $warning=$warning*1024*1024*1024;
                    }
                }
                else
                {
                    $warning=($max/100)*$warning;
                }
                if(!is_numeric($critical))
                {
                    if(preg_match('#([0-9]*)([GB|TB]*)#',$critical,$regs))
                    {
                        if($regs[2]=='TB')
                        {
                            $critical=$regs[1]*1024;
                        }
                        $critical=$critical*1024*1024*1024;
                    }
                }
                else
                {
                    $critical=($max*$critical)/100;
                }
                $state = 'OK';
                $line = $tmp[0];
                $message="< $messagewarning";
                if($line['used'] > $critical)
                {
                    $return = priority_state($return,$ERROR['CRITICAL']);
                    $state = 'CRITICAL';
                    $message = "> $messagecritical";
                }
                elseif($line['used'] > $warning)
                {
                    $return = priority_state($return,$ERROR['WARNING']);
                    $state = 'WARNING';
                    $message = "> $messagewarning";
                }
                $used = round($line['used']/1024/1024/1024,1)."GB";
                $usedpercent=round((($line['used']/$max)*100),0);
                $total = round($max/1024/1024/1024,1)."GB";
                $output="$state: storage used $usedpercent% ($used) on $total $message|used=".$line['used'].";percent=$usedpercent;total=$max";
                //$return = priority_state($return,$ERROR['WARNING']);
            }

        }
    }
    elseif($type =='sharepoint')
    {
        $day=7;
        if(isset($extraparams))
        {
            if(preg_match('#days=([0-9]*)#',$extraparams,$regs))
            {
                $day = $regs[1];
            }
        }
        if($name=='filestat')
        {
            $output = $api->getSharepointFileCount($day);
        }
        elseif($name=='fileactivity')
        {
            $output = $api->getSharepointFileActivity($day);
        }
        elseif($name=='sitestat')
        {
            $output = $api->getSharePointSiteUsageSite($day);
        }
        elseif($name=='siteusage')
        {
            $tmp = $api->getSharePointSiteUsage($day);
            if(isset($json))
            {
                $output = $tmp;
            }
            else
            {
                $max = 1024*1024*1024*1024;
                if(preg_match('#subscribe=([0-9]*)([GB|TB]*)#',$extraparams,$regs))
                {
                    $max = $regs[1];
                    $unit = $regs[2];
                    if($unit=='TB')
                    {
                        $max=$max*1024;
                    }
                    $max=$max*1024*1024*1024;
                }
                $messagewarning =  $warning;
                $messagecritical =  $critical;
                if(!is_numeric($warning))
                {
                    if(preg_match('#([0-9]*)([GB|TB]*)#',$warning,$regs))
                    {
                        if($regs[2]=='TB')
                        {
                            $warning=$regs[1]*1024;
                        }
                        $warning=$warning*1024*1024*1024;
                    }
                }
                else
                {
                    $warning=($max/100)*$warning;
                }
                if(!is_numeric($critical))
                {
                    if(preg_match('#([0-9]*)([GB|TB]*)#',$critical,$regs))
                    {
                        if($regs[2]=='TB')
                        {
                            $critical=$regs[1]*1024;
                        }
                        $critical=$critical*1024*1024*1024;
                    }
                }
                else
                {
                    $critical=($max*$critical)/100;
                }
                $state = 'OK';
                $line = $tmp[0];
                $message="< $messagewarning";
                if($line['used'] > $critical)
                {
                    $return = priority_state($return,$ERROR['CRITICAL']);
                    $state = 'CRITICAL';
                    $message = "> $messagecritical";
                }
                elseif($line['used'] > $warning)
                {
                    $return = priority_state($return,$ERROR['WARNING']);
                    $state = 'WARNING';
                    $message = "> $messagewarning";
                }
                $used = round($line['used']/1024/1024/1024,1)."GB";
                $usedpercent=round((($line['used']/$max)*100),0);
                $total = round($max/1024/1024/1024,1);
                if($total >= 1024)
                {
                    $total = round($total/1024,1).'TB';
                }
                else
                {
                    $total .='GB';
                }
                $output="$state: storage used $usedpercent% ($used) on $total $message|used=".$line['used'].";percent=$usedpercent;total=$max";
            }

        }
        elseif($name=='siteusagedetail')
        {
            $output = $api->getSharePointSiteUsageDetail($day);
        }
        else
        {
            echo "BAD Commande for name parameter\n";
            exit(3);
        }
    }
    elseif($type =='mailbox')
    {
        $day=7;
        if(isset($extraparams))
        {
            if(preg_match('#days=([0-9]*)#',$extraparams,$regs))
            {
                $day = $regs[1];
            }
        }
        if($name=='usage')
        {
            $output = $api->getMailboxUsageDetail($day);
            if(!isset($json))
            {
                $state='OK';
                $count_cri = 0;
                $count_warn = 0;
                foreach($output as $mail)
                {
                    if($mail['storage_used'] >= $mail['send_block_quota'] || $mail['storage_used'] >= $mail['send_received_block_quota'] || $mail['used'] > $critical)
                    {
                        $state = 'CRITICAL';
                        $count_cri++;
                    }
                    elseif($mail['storage_used'] >= $mail['send_warning_quota'] || $mail['used'] > $warning)
                    {
                        if($state != 'CRITICAL')
                        {
                            $state = 'WARNING';
                            $count_warn++;
                        }
                    }
                }
                if($state == 'CRITICAL')
                {
                    $output = "CRITICAL:  $count_cri mailbox use more than $critical% of space or have exceeded the quota\n";
                    $return = priority_state($return,$ERROR['CRITICAL']);
                }
                elseif($state == 'WARNING')
                {
                    $output = "WARNING:  $count_warn mailbox use more than $warning% of space or have exceeded the quota\n";
                    $return = priority_state($return,$ERROR['WARNING']);
                }
                else
                {
                    $output = "OK:  all mailbox have enough space\n";
                    $return = priority_state($return,$ERROR['OK']);
                }
            }
        }
        elseif($name=='activity')
        {
            if(!isset($json))
            {
                $output = $api->getMailboxActivity(30);
                $state='OK';
                $activity = $output[0];

                if($activity['send'] > $critical || $activity['received'] > $critical   )
                {

                    if($activity['send'] > $critical)
                    {
                        $output = "CRITICAL: too many emails were sent yesterday (".$activity['send']." > $critical)";
                    }
                    else
                    {
                        $output = "CRITICAL: too many emails were received yesterday (".$activity['received']." > $critical)";
                    }
                    $return = priority_state($return,$ERROR['CRITICAL']);
                }
                elseif($activity['send'] > $warning || $activity['received'] > $warning   )
                {
                    if($activity['send'] > $warning)
                    {
                        $output = "WARNING: too many emails were sent yesterday (".$activity['send']." > $warning)";
                    }
                    else
                    {
                        $output = "WARNING: too many emails were received yesterday (".$activity['received']." > $warning)";
                    }
                    $return = priority_state($return,$ERROR['WARNING']);
                }
                else
                {
                    $output = "OK: mail activity is normal (send: ".$activity['send']." < $warning, received: ".$activity['received']." < $warning )";
                    $return = priority_state($return,$ERROR['OK']);
                }
                $output.= "|send=".$activity['send'].",received=".$activity['received'].",read=".$activity['read'];
            }
            else
            {
                $output = $api->getMailboxActivity($day);
            }
        }
        elseif($name=='storage')
        {
            $output = $api->getMailboxStorage($day);
        }
        elseif($name=='count')
        {
            $output = $api->getMailboxCount($day);
        }
        elseif($name=='appUsage')
        {
            $output = $api->getAppUsage($day);
        }
    }
    elseif($type =='teams')
    {
        $day=7;
        if(isset($extraparams))
        {
            if(preg_match('#days=([0-9]*)#',$extraparams,$regs))
            {
                $day = $regs[1];
            }
        }
        if($name=='activity')
        {
            $output = $api->getTeamsActivity($day);
        }
        elseif($name=='userConnect')
        {
            $output = $api->getTeamsConnect($day);
        }
        elseif($name=='appUsage')
        {
            $output = $api->getTeamsAppUsage($day);
        }
    }
    elseif($type=='AD')
    {
        $sites = $api->getAzureADSync();
        $flag=false;
        if(!isset($json))
        {
            foreach($sites as $site)
            {
                if(preg_match("#$name#",$site['name']))
                {
                    $flag=true;
                    $date_sync = new DateTime($site['LastSync']);
                    $now = new DateTime();
                    $now = $now->getTimestamp();
                    $delta = $now - $date_sync->getTimestamp();
                    $warning_second = $warning*24*60*60;
                    $critical_second = $critical*24*60*60;
                    if($delta > $critical_second)
                    {
                        $output.='CRITICAL: '.$site['name'].' synchronization is to old ('.$date_sync->format('d-m-Y').') > '.$critical." day\n";
                        $return = priority_state($return,$ERROR['CRITICAL']);
                    }
                    elseif($delta > $warning_second)
                    {
                        $output.='WARNING: '.$site['name'].' synchronization is to old ('.$date_sync->format('d-m-Y').') > '.$warning." day\n";
                        $return = priority_state($return,$ERROR['WARNING']);
                    }
                    else
                    {
                        $output.='OK: '.$site['name'].' synchronization is OK ('.$date_sync->format('d-m-Y').') < '.$warning." day\n";
                        $return = priority_state($return,$ERROR['OK']);
                    }
                }
            }
            if($flag==false)
            {
                $output.='UNKNOWN: '.$name." not found \n";
                $return = priority_state($return,$ERROR['UNKNOWN']);
            }
        }
        else
        {
            $output = $sites;
        }
    }
    elseif($type=='messages')
    {
        $messages = $api->getMessages($name);
        $output=array();
        foreach($messages as $message)
        {
            if(!empty($name))
            {
                $output[]=array('id'=>$message['id'] ,'status'=>$message['status'], 'title'=>$message['title'],'Description'=>$message['impactDescription'],'start'=>$message['startDateTime'],
                                    'end'=>$message['endDateTime'],'lasttime'=>$message['lastModifiedDateTime'],'type'=>$message['featureGroup'],'messages'=>$message['posts']);
            }
        }
    }
    elseif($type=='allServices')
    {
        $services = $api->getServicesStatus();
        $output=array();
        foreach($services as $service)
        {
            $status = checkServiceStatus($service['status']);
            $output[] =array('state'=>$status['state'],'id'=>$service['service'],'message'=>$status['message'],'realstate'=>$service['status']);
        }
    }

    elseif($type=='check')
    {
        if(!empty($name))
        {
            $services = $api->getServicesStatus();
            foreach($services as $service)
            {
                $out= $service['id'].' status is '.$service['status'];
                //$allfeature = count($service['FeatureStatus']);
                if(strpos($service['service'],$name)!==FALSE || strpos($service['id'],$name)!==FALSE)
                {
                    $status = checkServiceStatus($service['status']);
                    $output.= $status['state'].": service ".$service['service']." is ".$status['message']."";
                    if($status['state'] !='OK')
                    {
                        $ok=0;
                       /* foreach($service['FeatureStatus'] as $feature)
                        {
                            $status = checkServiceStatus($feature['FeatureServiceStatus']);
                            $output.= "\t".$status['state'].": Feature ".$feature['FeatureDisplayName']." service is ".$status['message']."\n";
                            if($status['state'] =='OK' )
                            {
                                $ok++;
                            }
                        }*/
                        $return = priority_state($return,$ERROR['WARNING']);
                    }
                    else
                    {
                        $return = priority_state($return,$ERROR[$status['state']]);
                    }
                    $output.= " |ok=$ok;total=$allfeature;microsoftstate=".$service['status']."\n";
                }
            }
        }
        else
        {
            $services = $api->getServicesStatus();
            foreach($services as $service)
            {
                $status = checkServiceStatus($service['status']);
                $output.= $status['state'].": service ".$service['id']." is ".$status['message']."\n";
                $return = priority_state($return,$ERROR[$status['state']]);
            }
        }
    }
    else
    {
        echo "Unknown: BAD type parameter\n";
        exit(3);
    }
    if(isset($json))
    {
        echo json_encode($output);
    }
    elseif(is_array($output))
    {
        print_r($output);
    }
    else
    {
        echo "$output";
    }
}
catch(Exception $e)
{
    echo 'UNKNOWN: Error API '.$e->getMessage();
    exit(3);
}
exit($return);
//print_r($services);

function checkServiceStatus($status)
{
    $state='UNKNOWN';
    $message='Status is unknown';
    if($status=='serviceOperational'|| $status=='serviceRestored'  || $status=='PostIncidentReviewPublished' ||$status=='ExtendedRecovery')
    {
        $state = 'OK';
        $message = "operational";
    }
    elseif($status=='serviceInterruption')
    {
        $state = 'CRITICAL';
        $message = "down";
    }
    elseif($status=='Investigating' ||  $status=='VerifyingService')
    {
        $state = 'WARNING';
        $message = "investigating or verifying";
    }
    elseif($status=='serviceDegradation')
    {
        $state = 'WARNING';
        $message = "degraded";
    }
    elseif($status=='PIRPublished')
    {
        $state = 'WARNING';
        $message = "post incident published";
    }
    return array('state'=>$state,'message'=>$message);
}
class Microsoft365
{
    private $ch;
    private $token;
    private $baseuri;
    private $debug;
    private $tenantID;
    private $graphuri;
    private $cachedir;
	public function __construct($tenantID,$cachedir='/tmp/',$debug=0)
	{
        $this->debug = $debug;
        $this->token = null;
        $this->cachedir=$cachedir;
        $this->baseuri = "https://manage.office.com/api/v1.0/".$tenantID;
        $this->graphuri = "https://graph.microsoft.com/v1.0";
        $this->tenantID = urlencode($tenantID);
    }
    public function authentification($clientID,$key,$ressource='manage')
    {
        $urlparam="";
        $cachefile="";
        if($ressource=='graph')
        {
            $res='https://graph.microsoft.com/';
            $urlparam="?api-version=1.0";
            $cachefile=$this->tenantID."graph_token";
        }
        else
        {
            $res='https://manage.office.com';
            $cachefile=$this->tenantID."man_token";
        }

        $file = new CacheFile($this->cachedir.$cachefile,60);
        if($file->isValid())
        {
            $this->Trace("TOKEN_FILE: VALID");
            $this->token = $file->getData();
        }
        else
        {
            $this->Trace("TOKEN_FILE:EXPIRED");
            $this->Trace("Authentification");
            $post = array('grant_type'=>'client_credentials',
                          'client_id'=>$clientID,
                          'client_secret'=>$key,
                          'resource' => $res
                            );

            $response = $this->execCurl("https://login.microsoftonline.com/".$this->tenantID."/oauth2/token",$post, FALSE);
            $this->Trace("CURL RESPONSE");
            $response = json_decode($response,true);
            $this->Trace($response);
            $this->token = $response['access_token'];
            $file->writeData($this->token,$response['expires_on']);
        }



    }
    public function getServicesStatus()
    {
        //$this->Trace($this->graphuri.'/ServiceComms/Services');
        //$response = $this->execCurl($this->baseuri.'/ServiceComms/Services',$headers);
        //$response = $this->execCurl($this->baseuri.'/ServiceComms/CurrentStatus');
        $response = $this->execCurl($this->graphuri.'/admin/serviceAnnouncement/healthOverviews');
        $this->Trace("SERVICE RESPONSE");
        $response = json_decode($response,true);
        $this->Trace($response);
        return $response['value'];
    }
    public function getServices()
    {
        $this->Trace($this->baseuri.'/ServiceComms/Services');
        $response = $this->execCurl($this->baseuri.'/ServiceComms/Services');
        $this->Trace("SERVICE RESPONSE");
        $response = json_decode($response,true);
        $this->Trace($response);
        return $response['value'];
    }
    public function getMessages($id=null)
    {
        $url =$this->graphuri."/admin/serviceAnnouncement/issues";

        //$url = $this->baseuri.'/ServiceComms/Messages';
        /*if(!empty($id))
        {
            $url.="$id";
        }*/
        $this->Trace($url);
        $response = $this->execCurl($url);
        $this->Trace("SERVICE RESPONSE");
        $response = json_decode($response,true);
        $arr = array();
        if(!empty($id))
        {
            foreach($response['value'] as $issue)
            {
                if($issue["service"] == $id)
                {
                    $arr[]=$issue;
                }
            }
            $response['value']=$arr;
        }
        $this->Trace($response);
        return $response['value'];
    }
    public function getUserStatistic($day='7')
    {
        $this->Trace($this->graphuri."/reports/getOffice365ActiveUserDetail(period='D30')");
        $response = $this->execCurl( $this->graphuri."/reports/getOffice365ActiveUserCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        $headers=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[8];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[$date] = array('Office 365'=>$tmp[1],
                                        'Exchange'=>$tmp[2],
                                        'OneDrive'=>$tmp[3],
                                        'SharePoint'=>$tmp[4],
                                        'Skype'=>$tmp[5],
                                        'Yammer'=>$tmp[6],
                                        'Teams'=>$tmp[7]);

                }
            }
        }
        //$response = json_decode($response,true);
        $this->Trace($response);
        return $arr;
    }
    public function getUserActivate()
    {
        $this->Trace($this->graphuri."/reports/getOffice365ActivationCounts");
        $response = $this->execCurl($this->graphuri."/reports/getOffice365ActivationsUserCounts");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[8];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[$tmp[1]] = array('Date'=>$tmp[0],
                                        'Assigned'=>$tmp[2],
                                        'Activated'=>$tmp[3],
                                        'Shared Computer Activation'=>$tmp[4]);

                }
            }
        }
        return $arr;
    }
    public function getOnedriveFileActivity($day=7)
    {
        $this->Trace($this->graphuri."/reports/getOneDriveActivityFileCounts");
        $response = $this->execCurl($this->graphuri."/reports/getOneDriveActivityFileCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[5];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'viewed-edited'=>$tmp[1],
                                        'synced'=>$tmp[2],
                                       'shared-internally'=>$tmp[3],
                                       'shared-externally'=>$tmp[4]);
                }
            }
        }
        return $arr;
    }
    public function getOnedriveFileCount($day=7)
    {
        $this->Trace($this->graphuri."/reports/getOneDriveUsageFileCounts");
        $response = $this->execCurl($this->graphuri."/reports/getOneDriveUsageFileCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'site'=>$tmp[1],
                                        'total'=>$tmp[2],
                                       'active'=>$tmp[3]);

                }
            }
        }
        return $arr;
    }
    public function getOnedriveUserCount($day=7)
    {
        $this->Trace($this->graphuri."/reports/getOneDriveUsageAccountCounts");
        $response = $this->execCurl($this->graphuri."/reports/getOneDriveUsageAccountCounts(period='D$day')");
        $this->Trace("SERVICE RES/usr/local/esia/plugins/check_api_365.php -A /etc/esia/o365.cfg --json --type=onedrive --name userstat -DPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'site'=>$tmp[1],
                                        'total'=>$tmp[2],
                                       'active'=>$tmp[3]);

                }
            }
        }
        return $arr;
    }
    public function getOnedriveUserDetail($day=7)
    {
        $this->Trace($this->graphuri."/reports/getOneDriveUsageAccountDetail");
        $response = $this->execCurl($this->graphuri."/reports/getOneDriveUsageAccountDetail(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('owner'=>$tmp[3],
                    'last_activity'=>$tmp[5],
                    'file'=>$tmp[6],
                    'active_file'=>$tmp[7],
                    'used'=>$tmp[8],
                    'allocated'=>$tmp[9],
                    );

                }
            }
        }
        return $arr;
    }
    public function getOnedriveStorage($day=7)
    {
        $this->Trace($this->graphuri."/reports/getOneDriveUsageStorage");
        $response = $this->execCurl($this->graphuri."/reports/getOneDriveUsageStorage(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[3];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'type'=>$tmp[1],
                                        'used'=>$tmp[2]);

                }
            }
        }
        return $arr;
    }
    /*
    *SHAREPOINT
    */
    public function getSharepointFileActivity($day=7)
    {
        $this->Trace($this->graphuri."/reports/getSharePointActivityFileCounts");
        $response = $this->execCurl($this->graphuri."/reports/getSharePointActivityFileCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[5];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'viewed-edited'=>$tmp[1],
                                        'synced'=>$tmp[2],
                                       'shared-internally'=>$tmp[3],
                                       'shared-externally'=>$tmp[4]);
                }
            }
        }
        return $arr;
    }
    public function getSharepointFileCount($day=7)
    {
        $this->Trace($this->graphuri."/reports/getSharePointSiteUsageFileCounts");
        $response = $this->execCurl($this->graphuri."/reports/getSharePointSiteUsageFileCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($respogetAzureADDirectorynse as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'site'=>$tmp[1],
                                        'total'=>$tmp[2],
                                       'active'=>$tmp[3]);

                }
            }
        }
        return $arr;
    }
    public function getSharePointSiteUsageSite($day=7)
    {
        $this->Trace($this->graphuri."/reports/getSharePointSiteUsageSiteCounts");
        $response = $this->execCurl($this->graphuri."/reports/getSharePointSiteUsageSiteCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=> $date,
                                    'site'=>$tmp[1],
                                        'total'=>$tmp[2],
                                       'active'=>$tmp[3]);

                }
            }
        }
        return $arr;
    }
    public function getSharePointSiteUsage($day=7)
    {
        $this->Trace($this->graphuri."/reports/getSharePointSiteUsageStorage");
        $response = $this->execCurl($this->graphuri."/reports/getSharePointSiteUsageStorage(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('site'=>$tmp[1],
                                    'used'=>$tmp[2],
                                    'date'=>$tmp[3]
                                );

                }
            }
        }
        return $arr;
    }
    public function getSharePointSiteUsageDetail($day=7)
    {
        $this->Trace($this->graphuri."/reports/getSharePointSiteUsageDetail");
        $response = $this->execCurl($this->graphuri."/reports/getSharePointSiteUsageDetail(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('site'=>$tmp[1],
                                    'last_activity'=>$tmp[5],
                                    'name'=>$tmp[2],
                                    'file_count'=>$tmp[6],
                                    'active_file'=>$tmp[7],
                                    'page_view'=>$tmp[8],
                                    'page_visited'=>$tmp[9],
                                    'used'=>$tmp[10],
                                    'allocated'=>$tmp[11],
                                );

                }
            }
        }
        return $arr;
    }
    /*
    BOITE MAIL
    */
    public function getMailboxUsageDetail($day=7)
    {
        $this->Trace($this->graphuri."/reports/getMailboxUsageDetail");
        $response = $this->execCurl($this->graphuri."/reports/getMailboxUsageDetail(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $percent = ($tmp[8]/$tmp[11])*100;
                    $percent = round($percent,2);
                    $arr[] = array('name'=>$tmp[1],
                                    'show_name'=>$tmp[2],
                                    'last_activity'=>$tmp[6],
                                    'elem_count'=>$tmp[7],
                                    'storage_used'=>$tmp[8],
                                    'send_warning_quota'=>$tmp[9],
                                    'send_block_quota'=>$tmp[10],
                                    'send_received_block_quota'=>$tmp[11],
                                    'elem_delete'=>$tmp[12],
                                    'storage_delete'=>$tmp[13],
                                    'used'=>$percent
                                );

                }
            }
        }
        return $arr;
    }
    public function getMailboxActivity($day=7)
    {
        $this->Trace($this->graphuri."/reports/getEmailActivityCounts");
        $response = $this->execCurl($this->graphuri."/reports/getEmailActivityCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('send'=>$tmp[1],
                                    'received'=>$tmp[2],
                                    'read'=>$tmp[3],
                                    'date'=>$tmp[6]
                                );

                }
            }
        }
        return $arr;
    }
    public function getMailboxStorage($day=7)
    {
        $this->Trace($this->graphuri."/reports/getMailboxUsageStorage");
        $response = $this->execCurl($this->graphuri."/reports/getMailboxUsageStorage(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=>$tmp[2],
                                    'usage'=>$tmp[1]
                                );

                }
            }
        }
        return $arr;
    }
    public function getMailboxCount($day=7)
    {
        $this->Trace($this->graphuri."/reports/getMailboxUsageMailboxCounts");
        $response = $this->execCurl($this->graphuri."/reports/getMailboxUsageMailboxCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=>$tmp[3],
                                    'total'=>$tmp[1],
                                    'active'=>$tmp[2]
                                );

                }
            }
        }
        return $arr;
    }
    public function getAppUsage($day=7)
    {
        $this->Trace($this->graphuri."/reports/getEmailAppUsageUserCounts");
        $response = $this->execCurl($this->graphuri."/reports/getEmailAppUsageUserCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Office 365,Exchange,OneDrive,SharePoint,Skype For Business,Yammer,Teams,Report Date,Report Period
                    $arr[] = array('date'=>$tmp[10],
                                    'mac_mail'=>$tmp[1],
                                    'mac_outlook'=>$tmp[2],
                                    'windows_outlook'=>$tmp[3],
                                    'mobile_outlook'=>$tmp[4],
                                    'mobile_other'=>$tmp[5],
                                    'web_outlook'=>$tmp[6],
                                    'app_pop3'=>$tmp[7],
                                    'app_imap'=>$tmp[8],
                                    'app_smtp'=>$tmp[9],
                                );

                }
            }
        }
        return $arr;
    }
    public function getTeamsActivity($day=7)
    {
        $this->Trace($this->graphuri."/reports/getTeamsUserActivityCounts");
        $response = $this->execCurl($this->graphuri."/reports/getTeamsUserActivityCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Report Date,Team Chat Messages,Private Chat Messages,Calls,Meetings,Other Actions,Report Period
                    $arr[] = array('date'=>$tmp[1],
                                    'message_teams'=>$tmp[2],
                                    'message_private'=>$tmp[3],
                                    'calls'=>$tmp[4],
                                    'meeting'=>$tmp[5]
                                );

                }
            }
        }
        return $arr;
    }
    public function getTeamsConnect($day=7)
    {
        $this->Trace($this->graphuri."/reports/getTeamsUserActivityUserCounts");
        $response = $this->execCurl($this->graphuri."/reports/getTeamsUserActivityUserCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Report Date,Team Chat Messages,Private Chat Messages,Calls,Meetings,Other Actions,Report Period
                    $arr[] = array('date'=>$tmp[1],
                                    'message_teams'=>$tmp[2],
                                    'message_private'=>$tmp[3],
                                    'calls'=>$tmp[4],
                                    'meeting'=>$tmp[5],
                                    'other'=>trim($tmp[6]),
                                );

                }
            }
        }
        return $arr;
    }
    public function getTeamsAppUsage($day=7)
    {
        $this->Trace($this->graphuri."/reports/getTeamsDeviceUsageUserCounts");
        $response = $this->execCurl($this->graphuri."/reports/getTeamsDeviceUsageUserCounts(period='D$day')");
        $this->Trace("SERVICE RESPONSE");
        $response = explode("\n",$response);
        $i=0;
        $arr=array();
        foreach($response as $line)
        {
            $tmp = explode(",",$line);
            if(count($tmp)!=1)
            {
                if($i==0)
                {
                    foreach($tmp as $key => $value)
                    {
                        $headers[$key]=$value;
                    }
                    $i++;
                }
                else
                {
                    $date=$tmp[4];
                    //Report Refresh Date,Report Date,Team Chat Messages,Private Chat Messages,Calls,Meetings,Other Actions,Report Period
                    $arr[] = array('date'=>$tmp[9],
                                    'web'=>$tmp[1],
                                    'windows_phone'=>$tmp[2],
                                    'android'=>$tmp[3],
                                    'ios'=>$tmp[4],
                                    'mac'=>$tmp[5],
                                    'windows'=>$tmp[6],
                                );

                }
            }
        }
        return $arr;
    }
    public function getAzureADSync()
    {
        ///admin/serviceAnnouncement/healthOverviews/
        $this->Trace($this->graphuri."/auditLogs/directoryAudits");
        //onPremisesSyncEnabled
        //onPremisesLastSyncDateTime
        $response = $this->execCurl('https://graph.microsoft.com/beta/organization');
        $this->Trace("SERVICE RESPONSE");
        $response = json_decode($response,true);
        $i=0;
        $arr=array();
        foreach($response['value'] as $log)
        {
            if($log['onPremisesSyncEnabled'] == 1)
            {
                $arr[] = array('name'=>$log['displayName'],
                               'category'=>'organisation',
                                'LastSync'=>$log['onPremisesLastSyncDateTime']
                                );
            }
        }
        $response = $this->execCurl('https://graph.microsoft.com/beta/groups');
        $this->Trace("SERVICE RESPONSE");
        $response = json_decode($response,true);
        foreach($response['value'] as $log)
        {
            if($log['onPremisesSyncEnabled'] == 1)
            {
                $arr[] = array('name'=>$log['displayName'],
                               'category'=>'groups',
                                'LastSync'=>$log['onPremisesLastSyncDateTime']
                                );
            }
        }
        return $arr;
    }
    private function execCurl($url,$post=null, $cache = TRUE)
    {
        $this->Trace("CACHE_FILE: CHECK");
        $response=FALSE;
        if($cache == TRUE)
        {
            $this->Trace("CACHE_FILE: CHECK");
            if(preg_match('#([a-zA-Z0-9\(\)=\']*)$#',$url,$regs))
            {
                $path =  escapeshellcmd($this->tenantID.$regs[1]);
                $this->Trace("CACHE_FILE: CHECK".$this->cachedir.$path);
                $file = new CacheFile($this->cachedir.$path,60);
                if($file->isValid())
                {
                    $this->Trace("CACHE_FILE: VALID");
                    $response = $file->getData();
                }
                else
                {
                    $this->Trace("CACHE_FILE: NOT VALID");
                }
            }
        }
        if($response===FALSE)
        {
            $this->ch = curl_init();
            curl_setopt($this->ch, CURLOPT_URL, $url);
            curl_setopt($this->ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($this->ch, CURLOPT_RETURNTRANSFER,TRUE );
            curl_setopt($this->ch, CURLOPT_CUSTOMREQUEST, "GET");
            if ($this->token && !empty($this->token))
            {
                $this->Trace("CURL EXEC HEADERS");
                $headers = array('Accept: application/json;odata.metadata=none',"Authorization: Bearer ".$this->token);
                $this->Trace($headers);
                //curl_setopt( $this->ch, CURLOPT_HEADER,true );
                curl_setopt( $this->ch, CURLOPT_HTTPHEADER, $headers);
                curl_setopt( $this->ch, CURLOPT_VERBOSE, FALSE );
            }
            if(isset($post))
            {
                curl_setopt($this->ch, CURLOPT_POST, 1);
                curl_setopt($this->ch, CURLOPT_POSTFIELDS, $post);
            }
            else
            {
                $this->Trace("CURL GET");
                curl_setopt($this->ch, CURLOPT_CUSTOMREQUEST, "GET");
            }
            $this->Trace("CURL EXEC");
            $response = curl_exec($this->ch);
            if($response ===FALSE)
            {
                $this->Trace("Request failed");
                print_r( curl_getinfo($this->ch));
                throw new Exception("Can't login");
            }
            $state = curl_getinfo($this->ch);
            $this->Trace($state);
            if($state['http_code']==302 && !empty($state['redirect_url']))
            {
                $this->Trace("GET TEMP FILE");
                $response = file_get_contents($state['redirect_url']);
            }
            $this->Trace("CURL EXEC RESPONSE");
            $this->Trace($response);
            curl_close($this->ch);
            $err = json_decode($response, true);
            if(is_array($err))
            {
                if(isset($err['error']))
                {
                    //print_r($err['error']);
                    throw new Exception($err['error']);
                }
            }
            if($cache == TRUE)
            {
                $this->Trace("CACHE_FILE: WRITE");
                $file->writeData($response);
            }
        }
        return $response;
    }
    public function Trace($out)
    {
        if($this->debug !=0)
        {
            if(is_array($out))
            {
                echo "DEBUG CLASS Microsoft365 SHOW ARRAY\n";
                print_r($out);
                echo "================\n";
            }
            else
            {
                echo "DEBUG CLASS Microsoft365: ".$out."\n";
            }
        }
    }
}
function getParam($options,$name1,$name2,$default=null){
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}
function priority_state($a,$b)
{
    $arr = array('CRITICAL'=>2,'WARNING'=>1,'OK'=>0,'UNKNOWN'=>3);
    $state=$a;
    if($a == $b)
    {
        $state=$a;
    }
    elseif($a == $arr['CRITICAL'] || $b ==$arr['CRITICAL'])
    {
        $state=$arr['CRITICAL'];
    }
    elseif($b ==$arr['WARNING'] && $a !=$arr['CRITICAL'])
    {
        $state=$arr['WARNING'];
    }
    elseif($b ==$arr['UNKNOWN'] && $a == $arr['OK'])
    {
        $state=$arr['UNKNOWN'];
    }
    return $state;
}

?>
